-- marufight adapted from:
--https://github.com/groverburger/marufight

function setup()
    
    myImg = readImage(asset.builtin.Environments.Sunny_Back)
    vignetteH = math.min(WIDTH, HEIGHT)*0.45
    vignetteW = math.min(WIDTH, HEIGHT)*0.8
    level=5   --  0 thru 5
    flat=false  -- true (triangles) or false (rounded)
    insideView=true -- show inside view of sphere
    assert(craft, "Please include Craft as a dependency")
    assert(OrbitViewer, "Please include Cameras (not Camera) as a dependency")        
    scene = craft.scene()
    v=scene.camera:add(OrbitViewer, vec3(0,0,0), 350, 0, 600)
    scratchImage = image(WIDTH, HEIGHT)
    scene.ambientColor = color(239, 236, 233)
    spriteMode(CENTER)
    setContext()
    critter = NewCreature(xg,yg, braing,lineage,generation, radius,noselength, mutations)
    serialized = critter:serialize()
    revived = NewCreature()
    revived:restore(serialized)

    rel = math.max(WIDTH, HEIGHT)/1366
    local smallSetting = math.ceil(15*rel)
    local largeSetting = math.ceil(30*rel)
    parameter.action("Reset", function() 
        Reset()
    end)
    parameter.boolean("highlightOldest", true)
    parameter.integer("minCreatures", 1, 400, 40)
    parameter.integer("largest", 1, largeSetting * 4, smallSetting)
    parameter.integer("smallest", 1, largeSetting * 4, smallSetting)
    parameter.integer("food", 1, 500, 150)
    parameter.number("noseMultiplier", 1, 5, 1.6)
    parameter.integer("visionRange", 1, 300, 156)
    parameter.integer("lifespan", 1, 600, 35)
    parameter.boolean("reproduceAfterKilling", true)
    parameter.boolean("canEatWhileAggressive", true)
    parameter.boolean("cantKillFamily", true)
    parameter.boolean("Visual", true)
    
    oldest = {}
    Reset()
    createSphere(MFE.contextImage)   
end

function update(dt)
    scene:update(dt)
    sph.rotation = quat.eulerAngles(-90,0,0)
end

function draw()
    pushStyle()
    update(DeltaTime)
    scene:draw()
    MFE:draw()
    popStyle()
    setContext(scratchImage)
    sprite(MFE.contextImage, WIDTH/2, HEIGHT/2, WIDTH, HEIGHT)
    setContext()
    sprite(scratchImage, WIDTH - (vignetteW/2), vignetteH/2, vignetteW, vignetteH)
end

